Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.ibm.able.data
Class AbleFuzzySet

    java.lang.Object
      com.ibm.able.data.AbleLiteral
          com.ibm.able.data.AbleFuzzySet

All Implemented Interfaces:
  AbleRd, java.io.Serializable

Direct Known Subclasses:
  AbleFuzzySetBeta, AbleFuzzySetGaussian, AbleFuzzySetLinear, AbleFuzzySetPi, AbleFuzzySetSegments, AbleFuzzySetShoulder, AbleFuzzySetSigmoid, AbleFuzzySetTrapezoid, AbleFuzzySetTriangle, AbleFuzzySetWork

public abstract class AbleFuzzySet
extends AbleLiteral
implements java.io.Serializable

This class defines the Able data fuzzy set class.

See Also:
  Serialized Form

Field Summary
`static double` | `AlphaCutDefault` This is the default value used for alphacut when no explicit alphacut has been set.
`static int` | `AlphaCutStrong` Strong alphacut.
`static int` | `AlphaCutWeak` Weak alphacut.
`static int` | `CorrelationMethodDefault` Correlation method.
`static int` | `CorrelationMethodMinimise` Correlation method: Minimise: truncates the consequent fuzzy region at the truth of the premise (creating a plateau).
`static int` | `CorrelationMethodProduct` Correlation method: Product: scales the consequent fuzzy region using the truth of the predicate (the shape of the fuzzy region is preserved).
`static int` | `DefuzzifyMethodAverageHeight` Defuzzification method: Average: Take the average value of the fuzzy set.
`static int` | `DefuzzifyMethodCentroid` Defuzzification method: Centroid: Take the center of the fuzzy region.
`static int` | `DefuzzifyMethodDefault` Defuzzification method.
`static int` | `DefuzzifyMethodMaxHeight` Defuzzification method: MaxHeight: Take the value at the highest point.
`static int` | `FUZZY_ADD` Inference (implication) method: FuzzyAdd: also known as bounded add; the minimum of 1 and the sum of the membership values.
`static int` | `FuzzyInferenceMethodDefault` Fuzzy Inference (implication) method default: FuzzyAdd.
`static char` | `HedgeAbout` Hedge: About: Approximation (2.0) on bell-shaped fuzzy sets.
`static char` | `HedgeAbove` Hedge: Above: Restrict decreasing directional or bell-shaped fuzzy sets.
`static char` | `HedgeBelow` Hedge: Below: Restrict increasing directional or bell-shaped fuzzy sets.
`static char` | `HedgeCloseTo` Hedge: CloseTo: Narrow approximation (1.2) on bell-shaped fuzzy sets.
`static char` | `HedgeExtremely` Hedge: Extremely: Concentrate (3) any fuzzy set.
`static char` | `HedgeGenerally` Hedge: Generally: Diffuse (**0.5) any fuzzy set.
`static char` | `HedgeInVicinityOf` Hedge: InVicinityOf: Broad approximation (4.0) on bell-shaped fuzzy sets.
`static char` | `HedgeNot` Hedge: Not: Complement any fuzzy set.
`static char` | `HedgeNull` Hedge: Null: Ignored hedge, can be used as a place holder in a hedge string.
`static char` | `HedgePositively` Hedge: Positively: Intensify (**2) any fuzzy set.
`static char` | `HedgeSlightly` Hedge: Slightly: Dilute (0.3) any fuzzy set.
`static char` | `HedgeSomewhat` Hedge: Somewhat: Dilute (0.5) any fuzzy set.
`static char` | `HedgeVery` Hedge: Very: Concentrate (2) any fuzzy set.
`static int` | `MaxValues` The maximum number of scalars and truth values that can be held in a fuzzy set.
`static int` | `MIN_MAX` Inference (implication) method: MinMax: the maximum (of the minimum) membership values.
`protected double` | `myAlphaCut`
`protected boolean` | `myComplementFlag`
`protected java.lang.String` | `myComplementName`
`protected double` | `myDomainHi`
`protected double` | `myDomainLo`
`protected double` | `myFlexFactor`
`protected int` | `myNumberOfValues`
`protected AbleFuzzyVariable` | `myParentVar`
`protected double` | `myPtBeg`
`protected double` | `myPtCenter`
`protected double` | `myPtEnd`
`protected double` | `myPtFlex`
`protected double` | `myPtLeft`
`protected double` | `myPtLeftCore`
`protected double` | `myPtRight`
`protected double` | `myPtRightCore`
`protected double[]` | `myScalarVecSav`
`protected int` | `mySetDir`
`protected java.lang.String` | `mySetName`
`protected int` | `mySetType`
`protected double[]` | `myTruthVecSav`
`protected double[]` | `myTruthVector`
`protected double` | `myWeight`
`protected double` | `myWidth`
`static int` | `PRODUCT_OR` Inference (implication) method: ProductOr.
`static int` | `SetDirectionDown` Set direction: Down: for linear and sigmoid sets.
`static int` | `SetDirectionLeft` Set direction: Left: for shoulder sets.
`static int` | `SetDirectionRight` Set direction: Right: for shoulder sets.
`static int` | `SetDirectionUp` Set direction: Up: for linear and sigmoid sets.
`static int` | `SetTypeBeta` Set type: Beta: bell-shaped curve
`static int` | `SetTypeGaussian` Set type: Gaussian: bell-shaped curve
`static int` | `SetTypeLinear` Set type: Linear: straight line
`static int` | `SetTypePi` Set type: Pi: bell-shaped curve
`static int` | `SetTypeSegments` Set type: Segments: Straight line segments interpolated between specified points
`static int` | `SetTypeShoulder` Set type: Shoulder: Left or right plateaus
`static int` | `SetTypeSigmoid` Set type: Sigmoid: S-shaped curves
`static int` | `SetTypeTrapezoid` Set type: Trapezoid: plateau
`static int` | `SetTypeTriangle` Set type: Triangle:
`static int` | `SetTypeWork` Set type: Work: Used internally for copying and merging fuzzy set regions.

Constructor Summary
`protected` | `AbleFuzzySet(int theSetType, java.lang.String theSetName, AbleFuzzyVariable theParentVar, double theAlphaCut, double theDomainLo, double theDomainHi)` Create a new fuzzy set.

Method Summary
`java.lang.String` | `arlCRdString()` Return a formal ARL "clause read" string that describes this data object.
`static java.lang.String` | `CorrelationMethod(int theItem)` Given a CorrelationMethod constant, return a debug string.
`static java.lang.String` | `CorrelationMethodRl(int theItem)` Given a CorrelationMethod constant, return a rule language string.
`static java.lang.String` | `CorrelationMethodXml(int theItem)` Given a CorrelationMethod constant, return an XML string.
`static java.lang.String` | `DefuzzifyMethod(int theItem)` Given a DefuzzifyMethod constant, return a debug string.
`static java.lang.String` | `DefuzzifyMethodRl(int theItem)` Given a DefuzzifyMethod constant, return a rule language string.
`static java.lang.String` | `DefuzzifyMethodXml(int theItem)` Given a DefuzzifyMethod constant, return an XML string.
`static java.lang.String` | `FuzzyInferenceMethod(int theItem)` Given an inference method constant, return a human readable string of that constant.
`static java.lang.String` | `FuzzyInferenceMethodRl(int theItem)`
`static java.lang.String` | `FuzzyInferenceMethodXml(int theItem)`
`double` | `getAlphaCut()`
`boolean` | `getBooleanValue()` Retrieve the value of this data object as a boolean value.
`int` | `getDataType()` Retrieve the data type of this data object.
`java.lang.Class` | `getDataTypeClass()` Retrieve the actual class of this object's underlying data type.
`java.lang.String` | `getDataTypeClassName()` Retrieve the name of the class of this object's underlying data type.
`double` | `getDomainHi()`
`double` | `getDomainLo()`
`double` | `getFlexFactor()`
`AbleFuzzySet` | `getFuzzyValue()` Retrieve the value of this data object as a fuzzy value.
`java.lang.Object` | `getGenericValue()` Retrieve the value of this data object as an Object.
`int` | `getNumberOfValues()`
`double` | `getNumericValue()` Retrieve the value of this data object as a numeric value.
`double` | `getPtBeg()`
`double` | `getPtCenter()`
`double` | `getPtEnd()`
`double` | `getPtFlex()`
`double` | `getPtLeft()`
`double` | `getPtLeftCore()`
`double` | `getPtRight()`
`double` | `getPtRightCore()`
`int` | `getReferent()` Retrieve the Id of the variable to which this data object refers, if any.
`double[]` | `getScalarVector()`
`int` | `getSetDir()`
`java.lang.String` | `getSetName()`
`java.util.Vector` | `getSetProperties()`
`int` | `getSetType()`
`java.lang.String` | `getStringValue()` Retrieve the value of this data object as a string value.
`double[]` | `getTruthValues()`
`double[]` | `getTruthVector()`
`AbleLiteral` | `getValue()` Retrieve the value of this data object as a literal.
`double` | `getWeight()`
`double` | `getWidth()`
`static java.lang.String` | `Hedge(char theItem)` Given a Hedge constant, return a debug string.
`static java.lang.String` | `HedgeRl(char theItem)` Given a Hedge constant, return a rule language string.
`static java.lang.String` | `HedgeXml(char theItem)` Given a Hedge constant, return an XML string.
`void` | `setAlphaCut(double theAlphaCut)`
`static java.lang.String` | `SetDirection(int theItem)` Given a SetDirection constant, return a debug string.
`static java.lang.String` | `SetDirectionRl(int theItem)` Given a SetDirection constant, return a rule language string.
`static java.lang.String` | `SetDirectionXml(int theItem)` Given a SetDirection constant, return an XML string.
`static java.lang.String` | `SetType(int theItem)` Given a SetType constant, return a debug string.
`static java.lang.String` | `SetTypeRl(int theItem)` Given a SetType constant, return a rule language string.
`static java.lang.String` | `SetTypeXml(int theItem)` Given a SetType constant, return an XML string.
`java.lang.String` | `toString()` Retrieve a string describing (the contents of) the object.
`java.lang.String` | `traceString(int theTraceStringFlavor)` Retrieve a string describing (the contents of) the object.
`java.lang.String` | `xmlCRdString()` Return a formal XML "clause read" string that describes this data object.

Methods inherited from class com.ibm.able.data.AbleLiteral
`bitwiseAND, bitwiseNOT, bitwiseOR, bitwiseShiftLeft, bitwiseShiftRight, bitwiseShiftRightZeroFill, bitwiseXOR, cmpEq, cmpGt, cmpGtEq, cmpIs, cmpLt, cmpLtEq, cmpNeq, compDivide, compMinus, compModulo, compMultiply, compPlus, compUnaryMinus, getDataTypeAsString, getReferents, getTemplateString, isConstant, logicalAND, logicalNOT, logicalOR`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### MaxValues

    public static final int MaxValues

  The maximum number of scalars and truth values that can be held in a fuzzy set.

  See Also:
    Constant Field Values

### HedgeNull

    public static final char HedgeNull

  Hedge: Null: Ignored hedge, can be used as a place holder in a hedge string.

  See Also:
    Constant Field Values

### HedgeAbout

    public static final char HedgeAbout

  Hedge: About: Approximation (2.0) on bell-shaped fuzzy sets.

  See Also:
    Constant Field Values

### HedgeAbove

    public static final char HedgeAbove

  Hedge: Above: Restrict decreasing directional or bell-shaped fuzzy sets.

  See Also:
    Constant Field Values

### HedgeBelow

    public static final char HedgeBelow

  Hedge: Below: Restrict increasing directional or bell-shaped fuzzy sets.

  See Also:
    Constant Field Values

### HedgeCloseTo

    public static final char HedgeCloseTo

  Hedge: CloseTo: Narrow approximation (1.2) on bell-shaped fuzzy sets.

  See Also:
    Constant Field Values

### HedgeExtremely

    public static final char HedgeExtremely

  Hedge: Extremely: Concentrate (3) any fuzzy set.

  See Also:
    Constant Field Values

### HedgeGenerally

    public static final char HedgeGenerally

  Hedge: Generally: Diffuse (**0.5) any fuzzy set.

  See Also:
    Constant Field Values

### HedgeInVicinityOf

    public static final char HedgeInVicinityOf

  Hedge: InVicinityOf: Broad approximation (4.0) on bell-shaped fuzzy sets.

  See Also:
    Constant Field Values

### HedgeNot

    public static final char HedgeNot

  Hedge: Not: Complement any fuzzy set.

  See Also:
    Constant Field Values

### HedgePositively

    public static final char HedgePositively

  Hedge: Positively: Intensify (**2) any fuzzy set.

  See Also:
    Constant Field Values

### HedgeSlightly

    public static final char HedgeSlightly

  Hedge: Slightly: Dilute (0.3) any fuzzy set.

  See Also:
    Constant Field Values

### HedgeSomewhat

    public static final char HedgeSomewhat

  Hedge: Somewhat: Dilute (0.5) any fuzzy set.

  See Also:
    Constant Field Values

### HedgeVery

    public static final char HedgeVery

  Hedge: Very: Concentrate (2) any fuzzy set.

  See Also:
    Constant Field Values

### SetDirectionUp

    public static final int SetDirectionUp

  Set direction: Up: for linear and sigmoid sets.

  See Also:
    Constant Field Values

### SetDirectionDown

    public static final int SetDirectionDown

  Set direction: Down: for linear and sigmoid sets.

  See Also:
    Constant Field Values

### SetDirectionLeft

    public static final int SetDirectionLeft

  Set direction: Left: for shoulder sets.

  See Also:
    Constant Field Values

### SetDirectionRight

    public static final int SetDirectionRight

  Set direction: Right: for shoulder sets.

  See Also:
    Constant Field Values

### SetTypeBeta

    public static final int SetTypeBeta

  Set type: Beta: bell-shaped curve

  See Also:
    Constant Field Values

### SetTypeGaussian

    public static final int SetTypeGaussian

  Set type: Gaussian: bell-shaped curve

  See Also:
    Constant Field Values

### SetTypeLinear

    public static final int SetTypeLinear

  Set type: Linear: straight line

  See Also:
    Constant Field Values

### SetTypePi

    public static final int SetTypePi

  Set type: Pi: bell-shaped curve

  See Also:
    Constant Field Values

### SetTypeSegments

    public static final int SetTypeSegments

  Set type: Segments: Straight line segments interpolated between specified points

  See Also:
    Constant Field Values

### SetTypeShoulder

    public static final int SetTypeShoulder

  Set type: Shoulder: Left or right plateaus

  See Also:
    Constant Field Values

### SetTypeSigmoid

    public static final int SetTypeSigmoid

  Set type: Sigmoid: S-shaped curves

  See Also:
    Constant Field Values

### SetTypeTrapezoid

    public static final int SetTypeTrapezoid

  Set type: Trapezoid: plateau

  See Also:
    Constant Field Values

### SetTypeTriangle

    public static final int SetTypeTriangle

  Set type: Triangle:

  See Also:
    Constant Field Values

### SetTypeWork

    public static final int SetTypeWork

  Set type: Work: Used internally for copying and merging fuzzy set regions.

  See Also:
    Constant Field Values

### AlphaCutDefault

    public static final double AlphaCutDefault

  This is the default value used for alphacut when no explicit alphacut has been set.

  In this implementation, the default is set to 0.10.

  See Also:
    Constant Field Values

### AlphaCutStrong

    public static final int AlphaCutStrong

  Strong alphacut.

  See Also:
    Constant Field Values

### AlphaCutWeak

    public static final int AlphaCutWeak

  Weak alphacut.

  See Also:
    Constant Field Values

### CorrelationMethodProduct

    public static final int CorrelationMethodProduct

  Correlation method: Product: scales the consequent fuzzy region using the truth of the predicate (the shape of the fuzzy region is preserved). That is,

           a[i] = a[i] * PredicateTruth

  Usually used with InferenceMethod ProductOr or FuzzyAdd.

  See Also:
    Constant Field Values

### CorrelationMethodMinimise

    public static final int CorrelationMethodMinimise

  Correlation method: Minimise: truncates the consequent fuzzy region at the truth of the premise (creating a plateau). That is,

           a[i] = minimum( a[i], PredicateTruth )

  Usually used with InferenceMethod MinMax.

  See Also:
    Constant Field Values

### CorrelationMethodDefault

    public static final int CorrelationMethodDefault

  Correlation method. The value of this constant specifies the correlation method used when the correlation method is not explicitly set by the user.

  In this implementation, the default is set to Product.

  See Also:
    Constant Field Values

### DefuzzifyMethodCentroid

    public static final int DefuzzifyMethodCentroid

  Defuzzification method: Centroid: Take the center of the fuzzy region.

  See Also:
    Constant Field Values

### DefuzzifyMethodMaxHeight

    public static final int DefuzzifyMethodMaxHeight

  Defuzzification method: MaxHeight: Take the value at the highest point.

  See Also:
    Constant Field Values

### DefuzzifyMethodAverageHeight

    public static final int DefuzzifyMethodAverageHeight

  Defuzzification method: Average: Take the average value of the fuzzy set.

  See Also:
    Constant Field Values

### DefuzzifyMethodDefault

    public static final int DefuzzifyMethodDefault

  Defuzzification method. The value of this constant specifies the defuzzification method used when the defuzzification method is not explicitly set by the user.

  In this implementation, the default is set to Centroid.

  See Also:
    Constant Field Values

### FUZZY_ADD

    public static final int FUZZY_ADD

  Inference (implication) method: FuzzyAdd: also known as bounded add; the minimum of 1 and the sum of the membership values. That is,

           minimum( 1, a[i]+b[i] )

  Usually used with Product correlation method.

  See Also:
    Constant Field Values

### MIN_MAX

    public static final int MIN_MAX

  Inference (implication) method: MinMax: the maximum (of the minimum) membership values. That is,

           maximum( a[i], b[i] )

  Almost always used with Minimise correlation method.

  See Also:
    Constant Field Values

### PRODUCT_OR

    public static final int PRODUCT_OR

  Inference (implication) method: ProductOr.

           1 - ( (1-a[i]) * (1-b[i]) )

  Usually used with Product correlation method.

  See Also:
    Constant Field Values

### FuzzyInferenceMethodDefault

    public static final int FuzzyInferenceMethodDefault

  Fuzzy Inference (implication) method default: FuzzyAdd.

  See Also:
    Constant Field Values

### mySetType

    protected int mySetType

### mySetName

    protected java.lang.String mySetName

### myAlphaCut

    protected double myAlphaCut

### myDomainLo

    protected double myDomainLo

### myDomainHi

    protected double myDomainHi

### myTruthVector

    protected double[] myTruthVector

### myParentVar

    protected AbleFuzzyVariable myParentVar

### myComplementName

    protected java.lang.String myComplementName

### myComplementFlag

    protected boolean myComplementFlag

### myPtBeg

    protected double myPtBeg

### myPtCenter

    protected double myPtCenter

### myPtEnd

    protected double myPtEnd

### myPtFlex

    protected double myPtFlex

### myPtLeft

    protected double myPtLeft

### myPtLeftCore

    protected double myPtLeftCore

### myPtRightCore

    protected double myPtRightCore

### myPtRight

    protected double myPtRight

### myFlexFactor

    protected double myFlexFactor

### mySetDir

    protected int mySetDir

### myWeight

    protected double myWeight

### myWidth

    protected double myWidth

### myNumberOfValues

    protected int myNumberOfValues

### myScalarVecSav

    protected double[] myScalarVecSav

### myTruthVecSav

    protected double[] myTruthVecSav

Constructor Detail

### AbleFuzzySet

    protected AbleFuzzySet(int theSetType,
                           java.lang.String theSetName,
                           AbleFuzzyVariable theParentVar,
                           double theAlphaCut,
                           double theDomainLo,
                           double theDomainHi)

  Create a new fuzzy set.

Parameters:
  `theSetType` - A SetType constant specifying the type of this fuzzy set.

  `theSetName` - The name of this fuzzy set.

  `theParentVar` - A reference to the fuzzy variable that contains this fuzzy set.

  `theAlphaCut` - The low cut-off value for this fuzzy set.

  `theDomainLo` - The low value of the domain of this fuzzy set.

  `theDomainHi` - The high value of the domain of this fuzzy set.

Method Detail

### CorrelationMethod

    public static final java.lang.String CorrelationMethod(int theItem)

  Given a CorrelationMethod constant, return a debug string.

### CorrelationMethodRl

    public static final java.lang.String CorrelationMethodRl(int theItem)

  Given a CorrelationMethod constant, return a rule language string.

### CorrelationMethodXml

    public static final java.lang.String CorrelationMethodXml(int theItem)

  Given a CorrelationMethod constant, return an XML string.

### DefuzzifyMethod

    public static final java.lang.String DefuzzifyMethod(int theItem)

  Given a DefuzzifyMethod constant, return a debug string.

### DefuzzifyMethodRl

    public static final java.lang.String DefuzzifyMethodRl(int theItem)

  Given a DefuzzifyMethod constant, return a rule language string.

### DefuzzifyMethodXml

    public static final java.lang.String DefuzzifyMethodXml(int theItem)

  Given a DefuzzifyMethod constant, return an XML string.

### FuzzyInferenceMethod

    public static final java.lang.String FuzzyInferenceMethod(int theItem)

  Given an inference method constant, return a human readable string of that constant.

  Parameters:
    `theItem` - An inference method constant.

  Returns:
    A string of the form "n:AbleRuleSet.<constant_name>" where "n" the input parameter and "constant name" is the name of the constant represented by "n". If "n" is not a valid inference method, "n:AbleRuleSet.InferenceMethodIsUnrecognized" is returned.

### FuzzyInferenceMethodRl

    public static final java.lang.String FuzzyInferenceMethodRl(int theItem)

### FuzzyInferenceMethodXml

    public static final java.lang.String FuzzyInferenceMethodXml(int theItem)

### Hedge

    public static final java.lang.String Hedge(char theItem)

  Given a Hedge constant, return a debug string.

### HedgeRl

    public static final java.lang.String HedgeRl(char theItem)

  Given a Hedge constant, return a rule language string.

### HedgeXml

    public static final java.lang.String HedgeXml(char theItem)

  Given a Hedge constant, return an XML string. These must match the terms in the DTD!

### SetDirection

    public static final java.lang.String SetDirection(int theItem)

  Given a SetDirection constant, return a debug string.

### SetDirectionRl

    public static final java.lang.String SetDirectionRl(int theItem)

  Given a SetDirection constant, return a rule language string.

### SetDirectionXml

    public static final java.lang.String SetDirectionXml(int theItem)

  Given a SetDirection constant, return an XML string. These must match the terms in the DTD!

### SetType

    public static final java.lang.String SetType(int theItem)

  Given a SetType constant, return a debug string.

### SetTypeRl

    public static final java.lang.String SetTypeRl(int theItem)

  Given a SetType constant, return a rule language string.

### SetTypeXml

    public static final java.lang.String SetTypeXml(int theItem)

  Given a SetType constant, return an XML string. These must match the terms in the DTD!

### getPtBeg

    public final double getPtBeg()

### getPtCenter

    public final double getPtCenter()

### getPtEnd

    public final double getPtEnd()

### getPtFlex

    public final double getPtFlex()

### getPtLeft

    public final double getPtLeft()

### getPtLeftCore

    public final double getPtLeftCore()

### getPtRightCore

    public final double getPtRightCore()

### getPtRight

    public final double getPtRight()

### getFlexFactor

    public final double getFlexFactor()

### getSetDir

    public final int getSetDir()

### getWeight

    public final double getWeight()

### getWidth

    public final double getWidth()

### getNumberOfValues

    public final int getNumberOfValues()

### getScalarVector

    public final double[] getScalarVector()

### getTruthVector

    public final double[] getTruthVector()

### getBooleanValue

    public boolean getBooleanValue()
                            throws AbleDataException

  Retrieve the value of this data object as a boolean value.

  Specified by:
    `getBooleanValue` in interface `AbleRd`
  Specified by:
    `getBooleanValue` in class `AbleLiteral`
  Returns:
    A boolean, if the value of this object can be represented as a boolean value. If the current value is 0.0, false is returned; otherwise true is returned.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as a boolean value.

### getFuzzyValue

    public AbleFuzzySet getFuzzyValue()
                               throws AbleDataException

  Retrieve the value of this data object as a fuzzy value.

  Specified by:
    `getFuzzyValue` in interface `AbleRd`
  Specified by:
    `getFuzzyValue` in class `AbleLiteral`
  Returns:
    A fuzzy set, if the value of this object can be represented as a fuzzy value. This method always throws an exception.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as a fuzzy value.

### getGenericValue

    public java.lang.Object getGenericValue()
                                     throws AbleDataException

  Retrieve the value of this data object as an Object.

  Specified by:
    `getGenericValue` in interface `AbleRd`
  Specified by:
    `getGenericValue` in class `AbleLiteral`
  Returns:
    A Double object.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as an Object.

### getNumericValue

    public double getNumericValue()
                           throws AbleDataException

  Retrieve the value of this data object as a numeric value.

  Specified by:
    `getNumericValue` in interface `AbleRd`
  Specified by:
    `getNumericValue` in class `AbleLiteral`
  Returns:
    A double, if the value of this object can be represented as a numeric value.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as a numeric value.

### getStringValue

    public java.lang.String getStringValue()
                                    throws AbleDataException

  Retrieve the value of this data object as a string value.

  Specified by:
    `getStringValue` in interface `AbleRd`
  Specified by:
    `getStringValue` in class `AbleLiteral`
  Returns:
    A String, if the value of this object can be represented as a string value.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as a string value.

### getValue

    public AbleLiteral getValue()
                         throws AbleDataException

  Retrieve the value of this data object as a literal.

  Specified by:
    `getValue` in interface `AbleRd`
  Specified by:
    `getValue` in class `AbleLiteral`
  Returns:
    An AbleFuzzySet object.
  Throws:
    `AbleDataException` - If the value of this object cannot be represented as a literal.

### getReferent

    public int getReferent()

  Retrieve the Id of the variable to which this data object refers, if any.

  Specified by:
    `getReferent` in interface `AbleRd`
  Overrides:
    `getReferent` in class `AbleLiteral`
  Returns:
    The Id of the variable to which this data object refers, or AbleData.VarIdNull if this fuzzy set has not been added to a fuzzy variable.

### arlCRdString

    public java.lang.String arlCRdString()

  Return a formal ARL "clause read" string that describes this data object.

  Specified by:
    `arlCRdString` in interface `AbleRd`
  Specified by:
    `arlCRdString` in class `AbleLiteral`
  Returns:
    A String describing the data object in formal rule language.

### xmlCRdString

    public java.lang.String xmlCRdString()

  Return a formal XML "clause read" string that describes this data object.

  Specified by:
    `xmlCRdString` in interface `AbleRd`
  Specified by:
    `xmlCRdString` in class `AbleLiteral`
  Returns:
    A String describing the data object in XML.

### getSetType

    public final int getSetType()

### getSetName

    public final java.lang.String getSetName()

### setAlphaCut

    public final void setAlphaCut(double theAlphaCut)

### getAlphaCut

    public final double getAlphaCut()

### getDomainLo

    public final double getDomainLo()

### getDomainHi

    public final double getDomainHi()

### getTruthValues

    public final double[] getTruthValues()

### getSetProperties

    public java.util.Vector getSetProperties()

### getDataTypeClass

    public java.lang.Class getDataTypeClass()

  Description copied from class: `AbleLiteral`
  Retrieve the actual class of this object's underlying data type.

  Specified by:
    `getDataTypeClass` in interface `AbleRd`
  Specified by:
    `getDataTypeClass` in class `AbleLiteral`
  Returns:
    The class of the underlying data type.

### getDataTypeClassName

    public java.lang.String getDataTypeClassName()

  Description copied from class: `AbleLiteral`
  Retrieve the name of the class of this object's underlying data type.

  Specified by:
    `getDataTypeClassName` in interface `AbleRd`
  Specified by:
    `getDataTypeClassName` in class `AbleLiteral`
  Returns:
    A String that is the name of the class of the underlying data type.

### toString

    public java.lang.String toString()

  Retrieve a string describing (the contents of) the object.

  Overrides:
    `toString` in class `AbleLiteral`
  Returns:
    A String containing the current contents of the object.

### traceString

    public java.lang.String traceString(int theTraceStringFlavor)

  Retrieve a string describing (the contents of) the object.

  Specified by:
    `traceString` in interface `AbleRd`
  Specified by:
    `traceString` in class `AbleLiteral`
  Parameters:
    `theTraceStringFlavor` - An Able.TraceStringFlavor value.

  Returns:
    A String containing the current contents of the object.

### getDataType

    public int getDataType()

  Description copied from class: `AbleLiteral`
  Retrieve the data type of this data object.

  Specified by:
    `getDataType` in interface `AbleRd`
  Specified by:
    `getDataType` in class `AbleLiteral`
  Returns:
    An AbleData.<DataType> constant.
  See Also:
    `AbleRd.getDataType()`

Overview | Package | Class | Use | Tree | Serialized | Deprecated | Index | Help
| ABLE 2.3.0 07/13/2005 14:21:00
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

(C) Copyright IBM Corporation 1999, 2005